loadGlobalJS("include/xmlsax.js");
loadGlobalJS("include/xmlw3cdom.js");

// Full configuration
var configHash = newHash();

// List of key functions
var allFunctions = undefined;
// Associated descriptions
var allFunctionsDesc = undefined;
// Associated titles
var allFunctionsTitle = undefined;
// Xml content of sms tables
var allSmsTables = undefined;

var allSmsModes = new Array("lower", 0, "upper", 10, "digit", 20);

// Hash of all pre-defined menu items (id => index)
var sysmenu_hash;
// Array of all pre-defined menu items (id => value)
var sysmenu_array;

var font_default ;
var font_title ;
var font_big ;
var video_directory ;
var music_directory ;
var photos_directory ;

var video_player ;

// Assume a node contains text and only text. 
// Always returns a string (maybe empty)
function getNodeText(domDoc, node)
{
    var nodes,child;
    var i;
    var rslt = "";
    i = 0;
    nodes = node.getChildNodes();
    while(i < nodes.getLength()) {
	child = nodes.item(i);
	if (child.getNodeName() == "#text") {
	    rslt += child.getNodeValue();
	}
	i++;
    }
    return rslt;
}

function setNodeText(domDoc, node, text)
{
    var nodes,child;
    var textSet,i;
    var rslt = "";
    i = 0;
    nodes = node.getChildNodes();
    textSet = false;
    while(i < nodes.getLength()) {
	child = nodes.item(i);
	if (child.getNodeName() == "#text") {
	    child.setNodeValue(text);
	    textSet = true;
	    i++;
	    break;
	}
	i++;
    }
    if (textSet) {
	// Remove any other text object
	while(i < nodes.getLength()) {
	    child = nodes.item(i);
	    if (child.getNodeName() == "#text") {
		node.removeChild(child);
	    } else {
		i++;
	    }
	}
    } else {
	// Add a new textnode !
	child = domDoc.createTextNode(text);
	node.appendChild(child);
    }
}

function keyconfig_loadSmsTable(remotename, smstablename)
{
    var inputMap = getInputMap();
    
    print("load sms table : "+smstablename+" for remote "+remotename+"\n");
    // Reset the sms table for this remote
    inputMap.setSmsTableName(remotename, "");
    
    if (smstablename == "") return;
    
    inputMap.setSmsTableName(remotename, smstablename);
    
    if (allSmsTables == undefined) return;
    if (allSmsTables == null) return;
    
    var table = allSmsTables.getRoot().findChild(xmlAnd(xmlNameFilter("table"), xmlAttribFilter("name", smstablename)));
    if (table == null) return;
    
    var keys = table.findChilds(xmlNameFilter("key"));
    for(i = 0; i < keys.getItemCount(); ++i) {
	var key, id, iid, mode, text, base;
	key = keys.getItem(i);
	
	id = key.getAttribute("id");
	iid = parseInt(id, 10);
	if (isNaN(iid)) continue;
	
	mode = key.getAttribute("mode");
	base = 0;
	for(j = 0; j < allSmsModes.length; j+=2) {
	    if (mode == allSmsModes[j]) {
		base = allSmsModes[j + 1];
	    }
	}
	
	text = key.getText();
	
	print("set smscode for "+remotename + " id=" + iid + " text='"+text+"'\n");
	
	inputMap.setSmsCode(remotename, iid + base, text);
    }
}

function loadKeyConfigFile(path)
{
    var i, j;
    var inputMap = getInputMap();
    var f = newFile();
    f.path = path;
    if (!f.readContent()) {
	print("Unable to load file "+path+" : "+f.lastError+"\n");
	return false;
    }
    debug("file loaded\n");
    
    var xml = parseXml(f.content);
    
    if (xml == null) {
	print("Invalid xml file : "+path+"\n");
	return false;
    }
    
    var remotes = xml.getRoot().findChilds(xmlNameFilter("remote"));
    if (remotes.getItemCount() == 0) {
	print("No remote tag in xml file : "+path+"\n");
	return false;
    }
    
    for(i = 0; i < remotes.getItemCount(); ++i) {
	var remote, remotename, smstablename, smsdelay;
	var ismsdelay;
	remote = remotes.getItem(i);
	
	remotename = remote.getAttribute("name");
	if (remotename == "") continue;
	
	inputMap.addRemote(remotename);
	
	
	smstablename = remote.getAttribute("sms-table");
	if (smstablename != "") {
	    
	    keyconfig_loadSmsTable(remotename, smstablename);
	    smsdelay = remote.getAttribute("sms-delay");
	    ismsdelay = parseInt(smsdelay, 10);
	    if (isNaN(ismsdelay)) smsdelay = "2000";
	    if (ismsdelay < 1) ismsdelay = 1;
	    inputMap.setSmsDelay(remotename, smsdelay);
	} else {
	    inputMap.setSmsTableName(remotename, "");
	}
	
	var functions = remote.findChilds(xmlNameFilter("function"));
	
	for(j = 0; j < functions.getItemCount(); ++j) {
	    var functitle, funckey, func;
	    
	    func = functions.getItem(j);
	    functitle = func.getAttribute("name");
	    funckey = func.getText();
	    if ((functitle != "") && (funckey != "")) {
		inputMap.setInputKey(functitle, remotename, funckey);
	    }
	}
    }
    return true;
}

function loadKeyConfig() {
    try {
	if (loadKeyConfigFile(getUserConfDir() + "map.xml")) return;
    } catch (error) {
	print("Error reading " + getUserConfDir() + "map.xml : "+error.message+"\n");
    }
    
    print("no/invalid user key configuration. Using default.\n");
    
    try {
	if (loadKeyConfigFile(getDataDir() + "config/map.xml")) return;
    } catch (error) {
	print("Error reading " + getDataDir() + "config/map.xml : "+error.message+"\n");
    }
    print("no valid key configuration at all... no luck !\n");
}

function keyconfig_loadSpecificKeyMapFile(path) {
    var f = newFile();
    f.path = path;
    if (!f.readContent()) {
	print("Unable to load file "+path+" : "+f.lastError+"\n");
	return null;
    }
    
    var parser = new DOMImplementation();
    parser.preserveWhiteSpace = true;
    
    // load the XML into the parser and get the DOMDocument
    var domDoc = parser.loadXML(f.content);
    if (domDoc.getDocumentElement() == null) return null;
    return domDoc;
}

// Return a domdoc or throw an exception
function keyconfig_loadKeyMapFile() {
    var domDoc = keyconfig_loadSpecificKeyMapFile(getUserConfDir() + "map.xml");
    if (domDoc == null) {
	domDoc = keyconfig_loadSpecificKeyMapFile(getDataDir() + "config/map.xml");
	if (domDoc == null) {
	    throw new Error("no valid key configuration file found.");
	}
    }
    return domDoc;
}

function keyconfig_saveKeyMapFile(domDoc) {
    var docRoot = domDoc.getDocumentElement();
    var file = newFile();
    file.path = getUserConfDir() + "map.xml";
    file.content = docRoot.getXML();
    debug("savecontent now...\n");
    if (!file.saveContent()) {
	throw new Error("Unable to save " + file.path+" : " + file.lastError);
    }
    debug("Save key configuration is ok\n");
}

// Return a remote (create it if not found).
function keyconfig_findRemoteInXmlDoc(domDoc, remotename) {
    var i;
    var remote;
    var docRoot = domDoc.getDocumentElement();
    var remotes = docRoot.getElementsByTagName("remote");
    if (remotes == null) {
	remote = domDoc.createElement("remote");
	remote.setAttribute("name",remotename);
	docRoot.appendChild(remote);
	return remote;
    }
    
    for(i = 0; i < remotes.getLength(); ++i) {
	remote = remotes.item(i);
	var attr = remote.getAttributeNode("name");
	if (attr == null) { continue; }
	if (remotename == attr.getValue()) {
	    return remote;
	}
    }
    remote = domDoc.createElement("remote");
    remote.setAttribute("name",remotename);
    docRoot.appendChild(remote);
    return remote;
}

function loadKeyFunctionsFile(filename) {
    var path;
    var f = newFile();
    path = getDataDir() + "config/" + filename;
    f.path = path;
    if (!f.readContent()) {
	throw new Error("Unable to load file "+path+" : "+f.lastError);
    }
    print("loading "+path+"\n");
    var xml = parseXml(f.content);
    
    if (xml == null) {
	print("Invalid xml file : "+path+"\n");
	return false;
    }
    
    allFunctions = new Array();
    allFunctionsDesc = new Array();
    allFunctionsTitle = new Array();
    
    var funcs = xml.getRoot().findChilds(xmlNameFilter("function"));
    
    if (funcs.getItemCount() == 0) {
	print("no function in "+path+"\n");
	return false;
    }
    
    for( i = 0; i < funcs.getItemCount(); ++i) {
	var funcname, functitle, funcdesc;
	var func = funcs.getItem(i);
	funcname = func.getAttribute("name");
	
	title = func.findChild(xmlNameFilter("title"));
	if (title == null) continue;
	functitle = title.getText();
	
	desc = func.findChild(xmlNameFilter("description"));
	if (desc == null) continue;
	funcdesc = desc.getText();
	
	
	allFunctions.push(funcname);
	allFunctionsDesc.push(funcdesc);
	allFunctionsTitle.push(functitle);
    }
    
    return true;
}

/*
    // instantiate the W3C DOM Parser
    var parser = new DOMImplementation();
    // load the XML into the parser and get the DOMDocument
    var domDoc = parser.loadXML(f.content);
    f = undefined;
    
    // get the root node (in this case, it is ROOTNODE)
    var docRoot = domDoc.getDocumentElement();
    if (docRoot == null) {
	throw new Error("Invalid xml file : "+path);
    }
    
    var funcs = docRoot.getElementsByTagName("function");
    if (funcs == null) {
	throw new Error("No function tag in xml file : "+path);
    }
    allFunctions = new Array();
    allFunctionsDesc = new Array();
    allFunctionsTitle = new Array();
    for(i = 0; i < funcs.getLength(); ++i) {
	var funcname;
	var functitle,funcdesc;
	var func = funcs.item(i);
	var attr = func.getAttributeNode("name");
	if (attr == null) { continue; }
	funcname = "" + attr.getValue();
	
	var title = func.getElementsByTagName("title");
	if ((title != null) && title.getLength()) {
	    functitle = getNodeText(domDoc, title.item(0));
	} else {
	    functitle = "";
	}
	
	var desc = func.getElementsByTagName("description");
	if ((desc != null) && desc.getLength()) {
	    funcdesc = getNodeText(domDoc, desc.item(0));
	} else {
	    funcdesc = "";
	}
	
	allFunctions.push(funcname);
	allFunctionsDesc.push(funcdesc);
	allFunctionsTitle.push(functitle);
	
    }
    return true;
}
*/

function loadKeyFunctions() {
    var done, lang;
    if (allFunctions != undefined) {
	return;
    }
    done = false;
    
    debug("loading key functions\n");
    lang = getI18NLang();
    if (lang != "c") {
	try {
	    loadKeyFunctionsFile("functions-"+lang+".xml");
	    done = true;
	} catch(error) {
	    print("error : "+error.message+"\n");
	}
    }
    if (!done) {
	try {
	    loadKeyFunctionsFile("functions.xml");
	} catch(error) {
	    print("error : "+error.message+"\n");
	}
    }
}









function globalconfig_findSettingInXmlDoc(domDoc, settingName) {
    var setting;
    var docRoot = domDoc.getDocumentElement();
    var settings = docRoot.getElementsByTagName("setting");
    if (settings != null) {
	for(i = 0; i < settings.getLength(); ++i) {
	    setting = settings.item(i);
	    var attr = setting.getAttributeNode("name");
	    if (attr == null) { continue; }
	    if (settingName == attr.getValue()) {
		return setting;
	    }
	}
    }
    setting = domDoc.createElement("setting");
    setting.setAttribute("name",settingName);
    var txt = domDoc.createTextNode("");
    setting.appendChild(txt);
    docRoot.appendChild(setting);
    
    return setting;
}

function globalconfig_loadSpecificConfigFile(path)
{
    var f = newFile();
    f.path = path;
    if (!f.readContent()) {
	print("Unable to load file "+path+" : "+f.lastError+"\n");
	return null;
    }
    // instantiate the W3C DOM Parser
    var parser = new DOMImplementation();
    parser.preserveWhiteSpace = true;
    // load the XML into the parser and get the DOMDocument
    var domDoc = parser.loadXML(f.content);
    
    f = undefined;
    
    // get the root node (in this case, it is ROOTNODE)
    var docRoot = domDoc.getDocumentElement();
    if (docRoot == null) {
	print("Invalid xml file : "+path+"\n");
	return null;
    }
    return domDoc;
}

function globalconfig_loadConfigFile() {
    var domDoc = null;
    try {
	domDoc = globalconfig_loadSpecificConfigFile(getUserConfDir() + "config.xml");
    } catch(error) {
	print("error : "+error.message+"\n");
    }
    if (domDoc == null) {
	try {
	    domDoc = globalconfig_loadSpecificConfigFile(getDataDir() + "config/config.xml");
	} catch(error) {
	    print("error : "+error.message+"\n");
	}
	if (domDoc == null) {
	    throw new Error("Unable to load any global config file");
	}
    }
    return domDoc;
}

function loadGlobalConfigFile(path)
{
    var f;
    var i;
    var xml;
    var docRoot;
    
    print("loadGlobalConfigFile("+path+")\n");
    
    f = newFile();
    f.path = path;
    if (!f.readContent()) {
	print("Unable to load file "+path+" : "+f.lastError+"\n");
	return false;
    }
    
    xml = parseXml(f.content);
    
    if (xml == null) {
	print("Invalid xml file : " + path + "\n");
	return false;
    }
    
    var configs = xml.getRoot().findChilds(xmlNameFilter("setting"));
    if (configs.getItemCount() == 0) {
	print("No config in "+path+"\n");
    }
    for(i = 0; i < configs.getItemCount(); ++i) {
	var configname, configvalue;
	var config = configs.getItem(i);
	configname = config.getAttribute("name");
	
	if (configHash.exists(configname)) {
	    continue;
	}
	
	configvalue = config.getText();
	print("Configuration " + configname + " set to " + configvalue + "\n");
	debug("Configuration " + configname + " set to " + configvalue + "\n");
	configHash.set(configname, configvalue);
    }
    return false;
}

/*
    xml = globalconfig_loadSpecificConfigFile(path);
    if (domDoc == null) return false;
    docRoot = domDoc.getDocumentElement();
    var configs = docRoot.getElementsByTagName("setting");
    if (configs == null) {
	print("No setting tag in xml file : "+path+"\n");
	return false;
    }
    
    for(i = 0; i < configs.getLength(); ++i) {
	var configname;
	var config = configs.item(i);
	var attr = config.getAttributeNode("name");
	if (attr == null) { continue; }
	configname = attr.getValue();
	if (configHash.exists(configname)) {
	    continue;
	}
	
	var configvalue = getNodeText(domDoc,config);
	debug("Configuration " + configname + " set to " + configvalue + "\n");
	configHash.set(configname,configvalue);
    }
}
*/

function scanSystemMenu(hash,menuitem)
{
    var i;
    if ("sysid" in menuitem) {
	hash.set(menuitem.sysid,"1");
    }
    for(i = 0; i < menuitem.entries.length; ++i) {
	scanSystemMenu(hash,menuitem.entries[i]);
    }
}

function orderChildsOfMenuEntry(menuitem) 
{
    var i, j;
    var entries, keys;
    entries = new Array();
    keys = new Array();
    debug("orderChilds of "+menuitem.title+"\n");
    for(i = 0 ; i < menuitem.childs.length; ++i) {
	var item = menuitem.childs[i];
	if (item.tagname == "ENTRIES") {
	    debug("adding "+item.childs.length+" childs.\n");
	    for(j = 0; j < item.childs.length; ++j) {
		var menu;
		menu = item.childs[j];
		
		orderChildsOfMenuEntry(menu);
		menu.father = menuitem;
		entries.push(menu);
		debug("Adjusted father of "+menu.title+"\n");
		debug("menu.father is "+menu.father.title+"\n");
	    }
	    //delete(item.childs);
	} else if(item.tagname == "KEY") {
	    keys.push(item);
	}
    }
    delete(menuitem.childs);
    menuitem.entries = entries;
    menuitem.keys = keys;
    debug("orderChilds of "+menuitem.title+" done\n");
}


function loadSystemMenuItems(filename)
{
    sysmenu_hash = newHash();
    sysmenu_array = new Array();
    var prod = new newXmlProducer("cat "+filename);
    prod.newEntry = function(w) {
	var id,pos;
	if (!("sysid" in w)) {
	    return;
	}
	id = w.sysid;
	debug("new system menu : "+id+"\n");
	pos = sysmenu_array.length;
	sysmenu_hash.set(id, pos);
	orderChildsOfMenuEntry(w);
	sysmenu_array[pos] = w;
    }
    prod.start();
    prod.finish();
}

function loadStyle(refresh)
{
    var st;
    clearStyles();
    st = configHash.get("style");
    if (st == "") st = "default";
    debug("loading style "+st+"\n");
    loadXml("skins/" + st + "/style.xml");
    if (refresh) {
	screen.refreshTreeStyle();
	//screen.relayoutTree();
	//screen.refreshTreeDynamics();
    }
}

function loadGlobalConfig() 
{
    try {
	loadGlobalConfigFile(getUserConfDir() + "config.xml");
    } catch (error) {
	print("Error reading " + getUserConfDir() + "config.xml : "+error.message+"\n");
    }
    
    try {
	loadGlobalConfigFile(getDataDir() + "config/config.xml");
    } catch (error) {
	print("Error reading " + getDataDir() + "config/config.xml : "+error.message+"\n");
    }
    
    setI18NLang(configHash.get("language"));
    font_default = loadFont("fonts/"+configHash.get("font_default:file")+".ttf",configHash.get("font_default:size"));
    font_title = loadFont("fonts/"+configHash.get("font_title:file")+".ttf",configHash.get("font_title:size"));
    font_big = loadFont("fonts/"+configHash.get("font_big:file")+".ttf",configHash.get("font_big:size"));
    video_directory = configHash.get("video_directory");
    music_directory = configHash.get("music_directory");
    photos_directory = configHash.get("photos_directory");
    
    video_player = configHash.get("video_player");
}

function saveGlobalConfig()
{
    var domDoc;
    var settings;
    var i;
    domDoc = globalconfig_loadConfigFile();
    
    settings = configHash.getKeys();
    // Update the key in the config file
    for(i = 0; i < settings.getCount(); ++i) {
	var name = settings.getItem(i);
	var setting = globalconfig_findSettingInXmlDoc(domDoc, name);
	setNodeText(domDoc, setting, configHash.get(name));
    }
    
    // Save the file
    var file = newFile();
    var docRoot = domDoc.getDocumentElement();
    
    file.path = getUserConfDir() + "config.xml";
    file.content = docRoot.getXML();
    if (!file.saveContent()) {
	throw new Error("Unable to save " + file.path + " : " + file.lastError);
    }
}


// Suspend delay in minutes
function getSuspendDelay()
{
    var cfg = parseInt(configHash.get("suspend_delay"), 10);
    if (isNaN(cfg)) {
	return 1;
    }
    return cfg;
}

// Suspend minimum duration in minutes
function getSuspendMinimumDuration()
{
    var cfg = parseInt(configHash.get("suspend_minimum_duration"), 10);
    if (isNaN(cfg)) {
	return 10;
    }
    return cfg;
}

// In seconds
function getSuspendAnticipation()
{
    var cfg = parseInt(configHash.get("suspend_anticipation"), 10);
    if (isNaN(cfg)) {
	cfg = 10;
    }
    var suspendDuration = 60 * getSuspendMinimumDuration();
    if (cfg > suspendDuration) {
	cfg = suspendDuration;
    }
    return cfg;
}

// In seconds
function getWakeupInactivityDuration()
{
    var cfg = parseInt(configHash.get("wakeup_delay"), 10);
    if (isNaN(cfg)) {
	return 10;
    }
    return cfg;    
}




debug("initialisation of configuration\n");
if (system("utils/setup.sh",getDataDir(), getUserConfDir()) != 0) {
    throw new Error("unable to setup configuration...");
}

try {
    loadGlobalConfig();
    //saveGlobalConfig();
} catch(error) {
    print("error : "+error.message+"\n");
}

debug("loading sms tables\n");
try {
    var f = newFile();
    f.path = getDataDir() + "config/smstable.xml";
    if (!f.readContent()) {
	print("Unable to load file "+f.path+" : "+f.lastError+"\n");
    } else {
	allSmsTables = parseXml(f.content);
	if ( allSmsTables == null) {
	    print("Unable to load sms tables in "+f.path+"\n");
	    allSmsTables = parseXml("<sms-tables/>");
	}
    }
} catch(error) {
    print("error : "+error.message+"\n");
}

debug("loading key mappings\n");
try {
    loadKeyConfig();
} catch(error) {
    print("error : "+error.message+"\n");
}




try {
    if (!initApplication(configHash.get("resolution"),configHash.get("fullscreen") == 1)) {
    	initApplication("800x600",configHash.get("fullscreen") == 1);
    }
} catch(error) {
   print("error : "+error.message+"\n");
}

loadSystemMenuItems("system-menu-items.xml");

