// Various date handling functions
// Goal is to hide date or internalDate (ostbox specific) classes


var anydate = newDate();

// Take an internal date and make a timestamp in the format YYYYMMDDHHMISS
// Should no more be used outside of this file
function idateToTimestamp(d) 
{
    var dd,mm,yyyy,hour,min,sec;

    dd = new String(d.day);
    mm = new String(d.month + 1);
    yyyy = new String(d.year + 1900);
    hour = new String(d.hour);
    min = new String(d.minute);
    sec = new String(d.second);
    
    while(yyyy.length < 4) yyyy = "0"+yyyy;
    while(mm.length < 2) mm = "0" + mm;
    while(dd.length < 2) dd = "0" + dd;
    while(hour.length < 2) hour = "0" + hour;
    while(min.length < 2) min = "0" + min;
    while(sec.length < 2) sec = "0" + sec;
    
    return yyyy+mm+dd+hour+min+sec;
}

// Convert a local timestamp (yyyymmddhhmmss) into an epoch value
function timestampToEpoch(d)
{
    var dd,mm,yyyy,hour,min,sec;
    
    yyyy = d.substr(0,4);
    mm = d.substr(4,2);
    dd = d.substr(6,2);
    hour = d.substr(8,2);
    min = d.substr(10,2);
    sec = d.substr(12,2);
    
    anydate.local = true;
    
    anydate.setDate(parseInt(yyyy, 10) - 1900, parseInt(mm, 10) - 1, parseInt(dd, 10),
    		    parseInt(hour, 10), parseInt(min, 10), parseInt(sec, 10));
    
    return anydate.epoch;
}

// Take an internal date and make a timestamp in the format YYYYMMDDHHMISS
// Should no more be used outside of this file
function timestampToIDate(d) 
{
    var rslt = newDate();
    var dd,mm,yyyy,hour,min,sec;
    
    yyyy = d.substr(0,4);
    mm = d.substr(4,2);
    dd = d.substr(6,2);
    hour = d.substr(8,2);
    min = d.substr(10,2);
    sec = d.substr(12,2);
    
    rslt.local = true;
    
    rslt.setDate(parseInt(yyyy, 10) - 1900, parseInt(mm, 10) - 1, parseInt(dd, 10),
    		    parseInt(hour, 10), parseInt(min, 10), parseInt(sec, 10));

    return rslt;
}

function epochToTimestamp(epoch)
{
    anydate.local = true;
    anydate.epoch = epoch;
    return idateToTimestamp(anydate);
}

function nowTimestamp()
{
    anydate.local = true;
    anydate.now();
    return idateToTimestamp(anydate);
}

function nowEpoch()
{
    anydate.local = true;
    anydate.now();
    return anydate.epoch;
}

function timestampToDateString(timestamp)
{
    var dte = timestampToIDate(timestamp);
    return dte.dateString;
}

// Add some seconds to a timestamp
function timestampAdjust(timestamp, seconds)
{
    var dte = timestampToIDate(timestamp);
    dte.addSecond(seconds);
    return idateToTimestamp(dte);
}

function timestampAddDay(timestamp, number)
{
    var dte = timestampToIDate(timestamp);
    dte.addDay(number);
    return idateToTimestamp(dte);
}

