function fsBrowserHelper(browser) {
    var object = new Object();
    
    // Functions to set before using
    
    // 		Browser widget which contains childs
    object.browser = browser;
    // 		Callback when an update of the statusbar is needed
    object.updateStatusBar = undefined;
    //		Callback when the title must be updated
    object.setTitle = undefined;
    //		Callback when an item is clicked (excepted directories)
    object.itemClicked = undefined;
    //		Function which will receive all fs items. If returns false, item is hidden 
    object.filter = undefined;
    //		Function called each time a directory loading starts
    object.onDirLoad = undefined;
    // Private variables
    // 		Autoselected entry
    object.wanted = undefined;
    // 		io_performer reads directories
    object.io_performer = undefined;
    // 		current stack of fs object (root is always first entry)
    object.stack = new Array();
    //		path of the parent directory if any
    object.uppath = undefined;
    //		Name of the root
    object.rootTitle = "root";
    //		Path of the root
    object.rootPath = "/";
    //		Currently loaded path
    object.currentPath = undefined;
    
    object.triggerReload = newFileWatcher();
    object.triggerReload.father = object;
    object.triggerReload.onChange = function() { this.father.refresh(); };
    
    // Reload current directory
    object.refresh = function() {
	debug("reloading...\n");
	this.loadDirectory(this.currentPath, "refresh");
    }
    
    // Dirname : the path to load
    // pushit : is the path the root
    object.loadDirectory = function(dirname, pushit) {
	var path, vtitle, it;
	
	if (pushit == "refresh" && this.currentPath == undefined) return;
	
	this.triggerReload.path = dirname;
	if (this.io_performer != undefined) {
	    this.io_performer.cancel();
	    this.io_performer = undefined;
	}
	
	if (pushit == "push") {
	    path = this.browser.selectedItem();
	    if (path != undefined) {
		path = path.path;
	    }
	    this.stack[this.stack.length] = path;
	    this.wanted = undefined;
	    this.refreshMode = false;
	} else if (pushit == "pop") {
	    this.wanted = this.stack.pop();
	    this.refreshMode = false;
	} else if (pushit == "refresh") {
	    path = this.browser.selectedItem();
	    if (path != undefined) {
		path = path.path;
	    }
	    this.wanted = path;
	    dirname = this.currentPath;
	    this.refreshMode = true;
	    this.browser.filterItems(function(item) { item.deleteit = true; return true;});
    	} else {
	    this.stack = new Array();
	    this.wanted = undefined;
	    this.refreshMode = false;
	}
	
	vtitle = this.rootTitle;
	this.currentPath = dirname;
	
	if (!this.refreshMode) {
	    this.browser.clearItems();
	}
	
	this.io_performer = newXmlProducer('utils/ls.pl ' + shellEscape(dirname));
	this.io_performer.target = this;
	this.io_performer.newEntry = function(w) {
	    this.target.newEntry(w);
	}
	
	this.io_performer.done = function() {
	    this.target.dirDone();
	}
	
	this.io_performer.start();
	if (dirname != this.rootPath) {
	    var re = /^(.*)\/([^\/]+)(\/|)$/;
	    if (re.exec(dirname)) {
		vtitle = pathToDisplay(RegExp.$2);
		this.uppath = RegExp.$1;
		if (this.uppath == "") {
		    this.uppath = "/";
		}
	    } else {
		this.uppath = undefined;
	    }
	} else {
	    this.uppath = undefined;
	}
	
	if (this.onDirLoad != undefined) {
	    this.onDirLoad();
	}
	
	if (this.setTitle != undefined) {
	    this.setTitle(vtitle);
	}
    }

    object.newEntry = function(w)  
    {
	if (this.filter != undefined) {
	    if (!this.filter(w)) {
		return;
	    }
	}
	
	// Mark for no deletion
	w.deleteit = false;
	
	if ((!this.refreshMode) || (!this.browser.replaceItem(w,function(a,b) { return a.path == b.path; }))) {
	    this.browser.addItem(w);
	}
	
	if (!this.refreshMode) {
	    if (this.wanted != undefined && w.path == this.wanted) {
		this.browser.advance(this.browser.itemCount() - this.browser.selectedItemId());
		this.wanted = undefined;
	    }
	}
	
	if (this.updateStatusBar != undefined) {
	    this.updateStatusBar();
	}
    }
    
    object.dirDone = function () {
	this.wanted = undefined;
	if (this.io_performer != undefined) {
	    this.io_performer.cancel();
	    this.io_performer = undefined;
	}
	if (this.refreshMode) {
	    this.browser.filterItems(function(item) { return !item.deleteit; });
	}
    }
    
    
    // Move up in hierarchy
    // Return false if already at root. 
    // In this case, back key can be handled specially
    object.back = function() {
	debug("uppath is "+this.uppath+"\n");
	if (this.uppath != undefined) {
	    this.loadDirectory(this.uppath, "pop");
	    return true;
	} else {
	    return false;
	}
    } 
    
    object.clickCurrent = function() {
	var w = this.browser.selectedItem();
	if (w == undefined) return;
	if (w.type == "dir") {
	    this.loadDirectory(w.path, "push");
	} else {
	    this.itemClicked(w);
	}
    }
    
    object.setRoot = function(path, title) {
	this.rootTitle = title;
	this.rootPath = removeFinalSlash(path);
	this.loadDirectory(this.rootPath, "clear");
    }

    return object;
}

