/*
    adjustVolume(v) => change the volume level
    volctrl() => same, but with user feedback
    
    // Command can be +1, -1, mute, unmute, toggle
    
    listenVolumeChange(audio_user)	=> audio_user.audioVolumeChanged(v) will be called for each volume change
    		(regardless of current owner)
    
    All audio_user registered with listenVolumeChange :
	- audioVolumeChanged(newVolume)
*/

var lastVolume = 0;
var producer;
var volumeChangeList = new Array();
var wantFeedBack = false;
var volumeWidget = undefined;

function listenVolumeChange(user) {
    volumeChangeList[volumeChangeList.length] = user;
    user.audioVolumeChanged(0);
}

// The mixer answered...
function receiveVolume(value)
{
    var i, v, status;
    
    var table = value.split(/\s+/);
    v = table[0];
    status = table[1];
    
    if (wantFeedBack) {
	if (volumeWidget == undefined) {
	    w = loadXmlWidget("plugins/volume/volumelevel.xml", null)
	    w.removed = function() {
		volumeWidget = undefined;
	    }
	    w.keyMode = "pass";
	    volumeWidget = w;
	}

	if (status == "off") {
	    volumeWidget.textWidget.text = i18n("Volume : muted");
	} else {
	    volumeWidget.textWidget.text = i18n("Volume : $1%", v);
	}
	
	volumeWidget.textForm = volumeWidget.textWidget.text;
	front.show(volumeWidget,40);
	wantFeedBack = false;
    }
    
    debug("volume set. now has " + volumeChangeList.length + " item to notify\n");
    for(i = 0;i < volumeChangeList.length; ++i) {
	volumeChangeList[i].audioVolumeChanged(v);
    }
}

// Modify the volume, but reports nothing...
function adjustVolume(cmd)
{
    if (producer != undefined) {
	producer.kill(9);
	producer.cancel();
	producer = undefined;
    }
    producer = newProducer("utils/volume.sh "+cmd);
    producer.inform = this;
    producer.newEntry = function(str) { this.inform.receiveVolume(str); }
    producer.start();
}


// Modify the volume and report it...

// i is -1 (down), 1 (up) or 0 (mute/unmute)
function volctrl(i) {
    var vol,w;
    wantFeedBack = true;
    adjustVolume(i);
    
}

grabFunction("sound:volup", 5);
grabFunction("sound:voldown", 5);
grabFunction("sound:mute", 5);

