#!/bin/bash

ANGLE="$1"
FILE="$2"

case "$ANGLE" in
"90") 
	FILTER="rotate=1"
	;;
"180")	
	FILTER="flip,mirror"
	;;
"270")
	FILTER="rotate=2"
	;;
*)
	echo "Invalid angle : $ANGLE" 1>&2
	exit 1
esac

DIR=$(dirname "$FILE")
TMPNAME=".tmp.$$.jpg"
TMPFIC="$DIR/.$TMPNAME"
mencoder -quiet -vf "$FILTER" -oac copy -of avi -ovc lavc -lavcopts vcodec=mjpeg -o "$TMPFIC" "$FILE"
if [ "$?" == 0 ]; then
    mv -f "$TMPFIC" "$FILE"
    if [ "$?" != 0 ]; then
    	rm -f "$TMPFIC"
    fi
else
    rm -f "$TMPFIC"
fi
                        
                        
                        